// Copyright 2013 The Flutter Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// AUTO-GENERATED FILE.
// Generated by: tool/unicode_sync_script.dart
//
// Source:
// # WordBreakProperty-12.1.0.txt
// # Date: 2019-03-10, 10:53:28 GMT
// # © 2019 Unicode®, Inc.
// # Unicode and the Unicode Logo are registered trademarks of Unicode, Inc. in the U.S. and other countries.
// # For terms of use, see http://www.unicode.org/terms_of_use.html
// #
// # Unicode Character Database
// #   For documentation, see http://www.unicode.org/reports/tr44/

part of engine;

CharProperty getCharProperty(String text, int index) {
  if (index < 0 || index >= text.length) {
    return null;
  }
  return lookup.find(text.codeUnitAt(index));
}

enum CharProperty {
  DoubleQuote,
  SingleQuote,
  HebrewLetter,
  CR,
  LF,
  Newline,
  Extend,
  RegionalIndicator,
  Format,
  Katakana,
  ALetter,
  MidLetter,
  MidNum,
  MidNumLet,
  Numeric,
  ExtendNumLet,
  ZWJ,
  WSegSpace
}

const UnicodePropertyLookup<CharProperty> lookup =
    UnicodePropertyLookup<CharProperty>(<UnicodeRange<CharProperty>>[
  UnicodeRange<CharProperty>(0x000A, 0x000A, CharProperty.LF),
  UnicodeRange<CharProperty>(0x000B, 0x000C, CharProperty.Newline),
  UnicodeRange<CharProperty>(0x000D, 0x000D, CharProperty.CR),
  UnicodeRange<CharProperty>(0x0020, 0x0020, CharProperty.WSegSpace),
  UnicodeRange<CharProperty>(0x0022, 0x0022, CharProperty.DoubleQuote),
  UnicodeRange<CharProperty>(0x0027, 0x0027, CharProperty.SingleQuote),
  UnicodeRange<CharProperty>(0x002C, 0x002C, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0x002E, 0x002E, CharProperty.MidNumLet),
  UnicodeRange<CharProperty>(0x0030, 0x0039, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x003A, 0x003A, CharProperty.MidLetter),
  UnicodeRange<CharProperty>(0x003B, 0x003B, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0x0041, 0x005A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x005F, 0x005F, CharProperty.ExtendNumLet),
  UnicodeRange<CharProperty>(0x0061, 0x007A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0085, 0x0085, CharProperty.Newline),
  UnicodeRange<CharProperty>(0x00AA, 0x00AA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x00AD, 0x00AD, CharProperty.Format),
  UnicodeRange<CharProperty>(0x00B5, 0x00B5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x00B7, 0x00B7, CharProperty.MidLetter),
  UnicodeRange<CharProperty>(0x00BA, 0x00BA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x00C0, 0x00D6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x00D8, 0x00F6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x00F8, 0x02D7, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x02DE, 0x02E4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x02EC, 0x02FF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0300, 0x036F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0370, 0x0374, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0376, 0x0377, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x037A, 0x037D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x037E, 0x037E, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0x037F, 0x037F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0386, 0x0386, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0387, 0x0387, CharProperty.MidLetter),
  UnicodeRange<CharProperty>(0x0388, 0x038A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x038C, 0x038C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x038E, 0x03A1, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x03A3, 0x03F5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x03F7, 0x0481, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0483, 0x0489, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x048A, 0x052F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0531, 0x0556, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0559, 0x0559, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x055B, 0x055C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x055E, 0x055E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0560, 0x0588, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0589, 0x0589, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0x0591, 0x05BD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x05BF, 0x05BF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x05C1, 0x05C2, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x05C4, 0x05C5, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x05C7, 0x05C7, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x05D0, 0x05EA, CharProperty.HebrewLetter),
  UnicodeRange<CharProperty>(0x05EF, 0x05F2, CharProperty.HebrewLetter),
  UnicodeRange<CharProperty>(0x05F3, 0x05F3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x05F4, 0x05F4, CharProperty.MidLetter),
  UnicodeRange<CharProperty>(0x0600, 0x0605, CharProperty.Format),
  UnicodeRange<CharProperty>(0x060C, 0x060D, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0x0610, 0x061A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x061C, 0x061C, CharProperty.Format),
  UnicodeRange<CharProperty>(0x0620, 0x064A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x064B, 0x065F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0660, 0x0669, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x066B, 0x066B, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x066C, 0x066C, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0x066E, 0x066F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0670, 0x0670, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0671, 0x06D3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x06D5, 0x06D5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x06D6, 0x06DC, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x06DD, 0x06DD, CharProperty.Format),
  UnicodeRange<CharProperty>(0x06DF, 0x06E4, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x06E5, 0x06E6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x06E7, 0x06E8, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x06EA, 0x06ED, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x06EE, 0x06EF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x06F0, 0x06F9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x06FA, 0x06FC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x06FF, 0x06FF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x070F, 0x070F, CharProperty.Format),
  UnicodeRange<CharProperty>(0x0710, 0x0710, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0711, 0x0711, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0712, 0x072F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0730, 0x074A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x074D, 0x07A5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x07A6, 0x07B0, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x07B1, 0x07B1, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x07C0, 0x07C9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x07CA, 0x07EA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x07EB, 0x07F3, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x07F4, 0x07F5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x07F8, 0x07F8, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0x07FA, 0x07FA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x07FD, 0x07FD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0800, 0x0815, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0816, 0x0819, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x081A, 0x081A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x081B, 0x0823, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0824, 0x0824, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0825, 0x0827, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0828, 0x0828, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0829, 0x082D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0840, 0x0858, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0859, 0x085B, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0860, 0x086A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x08A0, 0x08B4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x08B6, 0x08BD, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x08D3, 0x08E1, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x08E2, 0x08E2, CharProperty.Format),
  UnicodeRange<CharProperty>(0x08E3, 0x0903, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0904, 0x0939, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x093A, 0x093C, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x093D, 0x093D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x093E, 0x094F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0950, 0x0950, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0951, 0x0957, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0958, 0x0961, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0962, 0x0963, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0966, 0x096F, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0971, 0x0980, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0981, 0x0983, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0985, 0x098C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x098F, 0x0990, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0993, 0x09A8, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x09AA, 0x09B0, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x09B2, 0x09B2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x09B6, 0x09B9, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x09BC, 0x09BC, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x09BD, 0x09BD, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x09BE, 0x09C4, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x09C7, 0x09C8, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x09CB, 0x09CD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x09CE, 0x09CE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x09D7, 0x09D7, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x09DC, 0x09DD, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x09DF, 0x09E1, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x09E2, 0x09E3, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x09E6, 0x09EF, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x09F0, 0x09F1, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x09FC, 0x09FC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x09FE, 0x09FE, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0A01, 0x0A03, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0A05, 0x0A0A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A0F, 0x0A10, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A13, 0x0A28, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A2A, 0x0A30, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A32, 0x0A33, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A35, 0x0A36, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A38, 0x0A39, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A3C, 0x0A3C, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0A3E, 0x0A42, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0A47, 0x0A48, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0A4B, 0x0A4D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0A51, 0x0A51, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0A59, 0x0A5C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A5E, 0x0A5E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A66, 0x0A6F, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0A70, 0x0A71, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0A72, 0x0A74, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A75, 0x0A75, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0A81, 0x0A83, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0A85, 0x0A8D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A8F, 0x0A91, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0A93, 0x0AA8, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0AAA, 0x0AB0, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0AB2, 0x0AB3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0AB5, 0x0AB9, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0ABC, 0x0ABC, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0ABD, 0x0ABD, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0ABE, 0x0AC5, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0AC7, 0x0AC9, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0ACB, 0x0ACD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0AD0, 0x0AD0, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0AE0, 0x0AE1, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0AE2, 0x0AE3, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0AE6, 0x0AEF, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0AF9, 0x0AF9, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0AFA, 0x0AFF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0B01, 0x0B03, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0B05, 0x0B0C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B0F, 0x0B10, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B13, 0x0B28, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B2A, 0x0B30, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B32, 0x0B33, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B35, 0x0B39, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B3C, 0x0B3C, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0B3D, 0x0B3D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B3E, 0x0B44, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0B47, 0x0B48, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0B4B, 0x0B4D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0B56, 0x0B57, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0B5C, 0x0B5D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B5F, 0x0B61, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B62, 0x0B63, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0B66, 0x0B6F, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0B71, 0x0B71, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B82, 0x0B82, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0B83, 0x0B83, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B85, 0x0B8A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B8E, 0x0B90, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B92, 0x0B95, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B99, 0x0B9A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B9C, 0x0B9C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0B9E, 0x0B9F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0BA3, 0x0BA4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0BA8, 0x0BAA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0BAE, 0x0BB9, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0BBE, 0x0BC2, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0BC6, 0x0BC8, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0BCA, 0x0BCD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0BD0, 0x0BD0, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0BD7, 0x0BD7, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0BE6, 0x0BEF, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0C00, 0x0C04, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0C05, 0x0C0C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0C0E, 0x0C10, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0C12, 0x0C28, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0C2A, 0x0C39, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0C3D, 0x0C3D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0C3E, 0x0C44, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0C46, 0x0C48, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0C4A, 0x0C4D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0C55, 0x0C56, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0C58, 0x0C5A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0C60, 0x0C61, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0C62, 0x0C63, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0C66, 0x0C6F, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0C80, 0x0C80, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0C81, 0x0C83, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0C85, 0x0C8C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0C8E, 0x0C90, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0C92, 0x0CA8, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0CAA, 0x0CB3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0CB5, 0x0CB9, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0CBC, 0x0CBC, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0CBD, 0x0CBD, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0CBE, 0x0CC4, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0CC6, 0x0CC8, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0CCA, 0x0CCD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0CD5, 0x0CD6, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0CDE, 0x0CDE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0CE0, 0x0CE1, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0CE2, 0x0CE3, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0CE6, 0x0CEF, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0CF1, 0x0CF2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0D00, 0x0D03, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0D05, 0x0D0C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0D0E, 0x0D10, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0D12, 0x0D3A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0D3B, 0x0D3C, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0D3D, 0x0D3D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0D3E, 0x0D44, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0D46, 0x0D48, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0D4A, 0x0D4D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0D4E, 0x0D4E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0D54, 0x0D56, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0D57, 0x0D57, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0D5F, 0x0D61, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0D62, 0x0D63, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0D66, 0x0D6F, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0D7A, 0x0D7F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0D82, 0x0D83, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0D85, 0x0D96, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0D9A, 0x0DB1, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0DB3, 0x0DBB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0DBD, 0x0DBD, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0DC0, 0x0DC6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0DCA, 0x0DCA, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0DCF, 0x0DD4, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0DD6, 0x0DD6, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0DD8, 0x0DDF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0DE6, 0x0DEF, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0DF2, 0x0DF3, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0E31, 0x0E31, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0E34, 0x0E3A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0E47, 0x0E4E, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0E50, 0x0E59, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0EB1, 0x0EB1, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0EB4, 0x0EBC, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0EC8, 0x0ECD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0ED0, 0x0ED9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0F00, 0x0F00, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0F18, 0x0F19, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0F20, 0x0F29, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x0F35, 0x0F35, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0F37, 0x0F37, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0F39, 0x0F39, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0F3E, 0x0F3F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0F40, 0x0F47, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0F49, 0x0F6C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0F71, 0x0F84, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0F86, 0x0F87, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0F88, 0x0F8C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x0F8D, 0x0F97, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0F99, 0x0FBC, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x0FC6, 0x0FC6, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x102B, 0x103E, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1040, 0x1049, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1056, 0x1059, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x105E, 0x1060, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1062, 0x1064, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1067, 0x106D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1071, 0x1074, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1082, 0x108D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x108F, 0x108F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1090, 0x1099, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x109A, 0x109D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10A0, 0x10C5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10C7, 0x10C7, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10CD, 0x10CD, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10D0, 0x10FA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10FC, 0x1248, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x124A, 0x124D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1250, 0x1256, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1258, 0x1258, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x125A, 0x125D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1260, 0x1288, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x128A, 0x128D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1290, 0x12B0, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x12B2, 0x12B5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x12B8, 0x12BE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x12C0, 0x12C0, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x12C2, 0x12C5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x12C8, 0x12D6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x12D8, 0x1310, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1312, 0x1315, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1318, 0x135A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x135D, 0x135F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1380, 0x138F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x13A0, 0x13F5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x13F8, 0x13FD, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1401, 0x166C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x166F, 0x167F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1680, 0x1680, CharProperty.WSegSpace),
  UnicodeRange<CharProperty>(0x1681, 0x169A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16A0, 0x16EA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16EE, 0x16F8, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1700, 0x170C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x170E, 0x1711, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1712, 0x1714, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1720, 0x1731, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1732, 0x1734, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1740, 0x1751, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1752, 0x1753, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1760, 0x176C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x176E, 0x1770, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1772, 0x1773, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x17B4, 0x17D3, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x17DD, 0x17DD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x17E0, 0x17E9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x180B, 0x180D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x180E, 0x180E, CharProperty.Format),
  UnicodeRange<CharProperty>(0x1810, 0x1819, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1820, 0x1878, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1880, 0x1884, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1885, 0x1886, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1887, 0x18A8, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x18A9, 0x18A9, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x18AA, 0x18AA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x18B0, 0x18F5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1900, 0x191E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1920, 0x192B, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1930, 0x193B, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1946, 0x194F, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x19D0, 0x19D9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1A00, 0x1A16, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1A17, 0x1A1B, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1A55, 0x1A5E, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1A60, 0x1A7C, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1A7F, 0x1A7F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1A80, 0x1A89, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1A90, 0x1A99, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1AB0, 0x1ABE, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1B00, 0x1B04, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1B05, 0x1B33, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1B34, 0x1B44, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1B45, 0x1B4B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1B50, 0x1B59, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1B6B, 0x1B73, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1B80, 0x1B82, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1B83, 0x1BA0, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1BA1, 0x1BAD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1BAE, 0x1BAF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1BB0, 0x1BB9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1BBA, 0x1BE5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1BE6, 0x1BF3, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1C00, 0x1C23, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1C24, 0x1C37, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1C40, 0x1C49, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1C4D, 0x1C4F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1C50, 0x1C59, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1C5A, 0x1C7D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1C80, 0x1C88, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1C90, 0x1CBA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1CBD, 0x1CBF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1CD0, 0x1CD2, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1CD4, 0x1CE8, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1CE9, 0x1CEC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1CED, 0x1CED, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1CEE, 0x1CF3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1CF4, 0x1CF4, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1CF5, 0x1CF6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1CF7, 0x1CF9, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1CFA, 0x1CFA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D00, 0x1DBF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1DC0, 0x1DF9, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1DFB, 0x1DFF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E00, 0x1F15, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F18, 0x1F1D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F20, 0x1F45, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F48, 0x1F4D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F50, 0x1F57, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F59, 0x1F59, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F5B, 0x1F5B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F5D, 0x1F5D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F5F, 0x1F7D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F80, 0x1FB4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1FB6, 0x1FBC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1FBE, 0x1FBE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1FC2, 0x1FC4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1FC6, 0x1FCC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1FD0, 0x1FD3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1FD6, 0x1FDB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1FE0, 0x1FEC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1FF2, 0x1FF4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1FF6, 0x1FFC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2000, 0x2006, CharProperty.WSegSpace),
  UnicodeRange<CharProperty>(0x2008, 0x200A, CharProperty.WSegSpace),
  UnicodeRange<CharProperty>(0x200C, 0x200C, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x200D, 0x200D, CharProperty.ZWJ),
  UnicodeRange<CharProperty>(0x200E, 0x200F, CharProperty.Format),
  UnicodeRange<CharProperty>(0x2018, 0x2019, CharProperty.MidNumLet),
  UnicodeRange<CharProperty>(0x2024, 0x2024, CharProperty.MidNumLet),
  UnicodeRange<CharProperty>(0x2027, 0x2027, CharProperty.MidLetter),
  UnicodeRange<CharProperty>(0x2028, 0x2029, CharProperty.Newline),
  UnicodeRange<CharProperty>(0x202A, 0x202E, CharProperty.Format),
  UnicodeRange<CharProperty>(0x202F, 0x202F, CharProperty.ExtendNumLet),
  UnicodeRange<CharProperty>(0x203F, 0x2040, CharProperty.ExtendNumLet),
  UnicodeRange<CharProperty>(0x2044, 0x2044, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0x2054, 0x2054, CharProperty.ExtendNumLet),
  UnicodeRange<CharProperty>(0x205F, 0x205F, CharProperty.WSegSpace),
  UnicodeRange<CharProperty>(0x2060, 0x2064, CharProperty.Format),
  UnicodeRange<CharProperty>(0x2066, 0x206F, CharProperty.Format),
  UnicodeRange<CharProperty>(0x2071, 0x2071, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x207F, 0x207F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2090, 0x209C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x20D0, 0x20F0, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x2102, 0x2102, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2107, 0x2107, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x210A, 0x2113, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2115, 0x2115, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2119, 0x211D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2124, 0x2124, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2126, 0x2126, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2128, 0x2128, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x212A, 0x212D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x212F, 0x2139, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x213C, 0x213F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2145, 0x2149, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x214E, 0x214E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2160, 0x2188, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x24B6, 0x24E9, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2C00, 0x2C2E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2C30, 0x2C5E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2C60, 0x2CE4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2CEB, 0x2CEE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2CEF, 0x2CF1, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x2CF2, 0x2CF3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2D00, 0x2D25, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2D27, 0x2D27, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2D2D, 0x2D2D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2D30, 0x2D67, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2D6F, 0x2D6F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2D7F, 0x2D7F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x2D80, 0x2D96, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2DA0, 0x2DA6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2DA8, 0x2DAE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2DB0, 0x2DB6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2DB8, 0x2DBE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2DC0, 0x2DC6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2DC8, 0x2DCE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2DD0, 0x2DD6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2DD8, 0x2DDE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x2DE0, 0x2DFF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x2E2F, 0x2E2F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x3000, 0x3000, CharProperty.WSegSpace),
  UnicodeRange<CharProperty>(0x3005, 0x3005, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x302A, 0x302F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x3031, 0x3035, CharProperty.Katakana),
  UnicodeRange<CharProperty>(0x303B, 0x303C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x3099, 0x309A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x309B, 0x309C, CharProperty.Katakana),
  UnicodeRange<CharProperty>(0x30A0, 0x30FA, CharProperty.Katakana),
  UnicodeRange<CharProperty>(0x30FC, 0x30FF, CharProperty.Katakana),
  UnicodeRange<CharProperty>(0x3105, 0x312F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x3131, 0x318E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x31A0, 0x31BA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x31F0, 0x31FF, CharProperty.Katakana),
  UnicodeRange<CharProperty>(0x32D0, 0x32FE, CharProperty.Katakana),
  UnicodeRange<CharProperty>(0x3300, 0x3357, CharProperty.Katakana),
  UnicodeRange<CharProperty>(0xA000, 0xA48C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA4D0, 0xA4FD, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA500, 0xA60C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA610, 0xA61F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA620, 0xA629, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0xA62A, 0xA62B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA640, 0xA66E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA66F, 0xA672, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA674, 0xA67D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA67F, 0xA69D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA69E, 0xA69F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA6A0, 0xA6EF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA6F0, 0xA6F1, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA717, 0xA7BF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA7C2, 0xA7C6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA7F7, 0xA801, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA802, 0xA802, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA803, 0xA805, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA806, 0xA806, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA807, 0xA80A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA80B, 0xA80B, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA80C, 0xA822, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA823, 0xA827, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA840, 0xA873, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA880, 0xA881, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA882, 0xA8B3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA8B4, 0xA8C5, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA8D0, 0xA8D9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0xA8E0, 0xA8F1, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA8F2, 0xA8F7, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA8FB, 0xA8FB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA8FD, 0xA8FE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA8FF, 0xA8FF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA900, 0xA909, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0xA90A, 0xA925, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA926, 0xA92D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA930, 0xA946, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA947, 0xA953, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA960, 0xA97C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA980, 0xA983, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA984, 0xA9B2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA9B3, 0xA9C0, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA9CF, 0xA9CF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xA9D0, 0xA9D9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0xA9E5, 0xA9E5, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xA9F0, 0xA9F9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0xAA00, 0xAA28, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAA29, 0xAA36, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAA40, 0xAA42, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAA43, 0xAA43, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAA44, 0xAA4B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAA4C, 0xAA4D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAA50, 0xAA59, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0xAA7B, 0xAA7D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAAB0, 0xAAB0, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAAB2, 0xAAB4, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAAB7, 0xAAB8, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAABE, 0xAABF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAAC1, 0xAAC1, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAAE0, 0xAAEA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAAEB, 0xAAEF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAAF2, 0xAAF4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAAF5, 0xAAF6, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xAB01, 0xAB06, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAB09, 0xAB0E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAB11, 0xAB16, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAB20, 0xAB26, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAB28, 0xAB2E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAB30, 0xAB67, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xAB70, 0xABE2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xABE3, 0xABEA, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xABEC, 0xABED, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xABF0, 0xABF9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0xAC00, 0xD7A3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xD7B0, 0xD7C6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xD7CB, 0xD7FB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFB00, 0xFB06, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFB13, 0xFB17, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFB1D, 0xFB1D, CharProperty.HebrewLetter),
  UnicodeRange<CharProperty>(0xFB1E, 0xFB1E, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xFB1F, 0xFB28, CharProperty.HebrewLetter),
  UnicodeRange<CharProperty>(0xFB2A, 0xFB36, CharProperty.HebrewLetter),
  UnicodeRange<CharProperty>(0xFB38, 0xFB3C, CharProperty.HebrewLetter),
  UnicodeRange<CharProperty>(0xFB3E, 0xFB3E, CharProperty.HebrewLetter),
  UnicodeRange<CharProperty>(0xFB40, 0xFB41, CharProperty.HebrewLetter),
  UnicodeRange<CharProperty>(0xFB43, 0xFB44, CharProperty.HebrewLetter),
  UnicodeRange<CharProperty>(0xFB46, 0xFB4F, CharProperty.HebrewLetter),
  UnicodeRange<CharProperty>(0xFB50, 0xFBB1, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFBD3, 0xFD3D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFD50, 0xFD8F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFD92, 0xFDC7, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFDF0, 0xFDFB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFE00, 0xFE0F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xFE10, 0xFE10, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0xFE13, 0xFE13, CharProperty.MidLetter),
  UnicodeRange<CharProperty>(0xFE14, 0xFE14, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0xFE20, 0xFE2F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xFE33, 0xFE34, CharProperty.ExtendNumLet),
  UnicodeRange<CharProperty>(0xFE4D, 0xFE4F, CharProperty.ExtendNumLet),
  UnicodeRange<CharProperty>(0xFE50, 0xFE50, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0xFE52, 0xFE52, CharProperty.MidNumLet),
  UnicodeRange<CharProperty>(0xFE54, 0xFE54, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0xFE55, 0xFE55, CharProperty.MidLetter),
  UnicodeRange<CharProperty>(0xFE70, 0xFE74, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFE76, 0xFEFC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFEFF, 0xFEFF, CharProperty.Format),
  UnicodeRange<CharProperty>(0xFF07, 0xFF07, CharProperty.MidNumLet),
  UnicodeRange<CharProperty>(0xFF0C, 0xFF0C, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0xFF0E, 0xFF0E, CharProperty.MidNumLet),
  UnicodeRange<CharProperty>(0xFF10, 0xFF19, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0xFF1A, 0xFF1A, CharProperty.MidLetter),
  UnicodeRange<CharProperty>(0xFF1B, 0xFF1B, CharProperty.MidNum),
  UnicodeRange<CharProperty>(0xFF21, 0xFF3A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFF3F, 0xFF3F, CharProperty.ExtendNumLet),
  UnicodeRange<CharProperty>(0xFF41, 0xFF5A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFF66, 0xFF9D, CharProperty.Katakana),
  UnicodeRange<CharProperty>(0xFF9E, 0xFF9F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xFFA0, 0xFFBE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFFC2, 0xFFC7, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFFCA, 0xFFCF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFFD2, 0xFFD7, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFFDA, 0xFFDC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0xFFF9, 0xFFFB, CharProperty.Format),
  UnicodeRange<CharProperty>(0x10000, 0x1000B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1000D, 0x10026, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10028, 0x1003A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1003C, 0x1003D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1003F, 0x1004D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10050, 0x1005D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10080, 0x100FA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10140, 0x10174, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x101FD, 0x101FD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10280, 0x1029C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x102A0, 0x102D0, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x102E0, 0x102E0, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10300, 0x1031F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1032D, 0x1034A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10350, 0x10375, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10376, 0x1037A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10380, 0x1039D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x103A0, 0x103C3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x103C8, 0x103CF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x103D1, 0x103D5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10400, 0x1049D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x104A0, 0x104A9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x104B0, 0x104D3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x104D8, 0x104FB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10500, 0x10527, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10530, 0x10563, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10600, 0x10736, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10740, 0x10755, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10760, 0x10767, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10800, 0x10805, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10808, 0x10808, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1080A, 0x10835, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10837, 0x10838, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1083C, 0x1083C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1083F, 0x10855, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10860, 0x10876, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10880, 0x1089E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x108E0, 0x108F2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x108F4, 0x108F5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10900, 0x10915, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10920, 0x10939, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10980, 0x109B7, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x109BE, 0x109BF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10A00, 0x10A00, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10A01, 0x10A03, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10A05, 0x10A06, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10A0C, 0x10A0F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10A10, 0x10A13, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10A15, 0x10A17, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10A19, 0x10A35, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10A38, 0x10A3A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10A3F, 0x10A3F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10A60, 0x10A7C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10A80, 0x10A9C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10AC0, 0x10AC7, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10AC9, 0x10AE4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10AE5, 0x10AE6, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10B00, 0x10B35, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10B40, 0x10B55, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10B60, 0x10B72, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10B80, 0x10B91, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10C00, 0x10C48, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10C80, 0x10CB2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10CC0, 0x10CF2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10D00, 0x10D23, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10D24, 0x10D27, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10D30, 0x10D39, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x10F00, 0x10F1C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10F27, 0x10F27, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10F30, 0x10F45, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x10F46, 0x10F50, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x10FE0, 0x10FF6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11000, 0x11002, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11003, 0x11037, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11038, 0x11046, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11066, 0x1106F, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1107F, 0x11082, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11083, 0x110AF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x110B0, 0x110BA, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x110BD, 0x110BD, CharProperty.Format),
  UnicodeRange<CharProperty>(0x110CD, 0x110CD, CharProperty.Format),
  UnicodeRange<CharProperty>(0x110D0, 0x110E8, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x110F0, 0x110F9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x11100, 0x11102, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11103, 0x11126, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11127, 0x11134, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11136, 0x1113F, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x11144, 0x11144, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11145, 0x11146, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11150, 0x11172, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11173, 0x11173, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11176, 0x11176, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11180, 0x11182, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11183, 0x111B2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x111B3, 0x111C0, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x111C1, 0x111C4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x111C9, 0x111CC, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x111D0, 0x111D9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x111DA, 0x111DA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x111DC, 0x111DC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11200, 0x11211, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11213, 0x1122B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1122C, 0x11237, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1123E, 0x1123E, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11280, 0x11286, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11288, 0x11288, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1128A, 0x1128D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1128F, 0x1129D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1129F, 0x112A8, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x112B0, 0x112DE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x112DF, 0x112EA, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x112F0, 0x112F9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x11300, 0x11303, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11305, 0x1130C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1130F, 0x11310, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11313, 0x11328, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1132A, 0x11330, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11332, 0x11333, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11335, 0x11339, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1133B, 0x1133C, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1133D, 0x1133D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1133E, 0x11344, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11347, 0x11348, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1134B, 0x1134D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11350, 0x11350, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11357, 0x11357, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1135D, 0x11361, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11362, 0x11363, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11366, 0x1136C, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11370, 0x11374, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11400, 0x11434, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11435, 0x11446, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11447, 0x1144A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11450, 0x11459, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1145E, 0x1145E, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1145F, 0x1145F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11480, 0x114AF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x114B0, 0x114C3, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x114C4, 0x114C5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x114C7, 0x114C7, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x114D0, 0x114D9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x11580, 0x115AE, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x115AF, 0x115B5, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x115B8, 0x115C0, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x115D8, 0x115DB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x115DC, 0x115DD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11600, 0x1162F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11630, 0x11640, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11644, 0x11644, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11650, 0x11659, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x11680, 0x116AA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x116AB, 0x116B7, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x116B8, 0x116B8, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x116C0, 0x116C9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1171D, 0x1172B, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11730, 0x11739, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x11800, 0x1182B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1182C, 0x1183A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x118A0, 0x118DF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x118E0, 0x118E9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x118FF, 0x118FF, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x119A0, 0x119A7, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x119AA, 0x119D0, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x119D1, 0x119D7, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x119DA, 0x119E0, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x119E1, 0x119E1, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x119E3, 0x119E3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x119E4, 0x119E4, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11A00, 0x11A00, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11A01, 0x11A0A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11A0B, 0x11A32, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11A33, 0x11A39, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11A3A, 0x11A3A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11A3B, 0x11A3E, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11A47, 0x11A47, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11A50, 0x11A50, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11A51, 0x11A5B, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11A5C, 0x11A89, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11A8A, 0x11A99, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11A9D, 0x11A9D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11AC0, 0x11AF8, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11C00, 0x11C08, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11C0A, 0x11C2E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11C2F, 0x11C36, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11C38, 0x11C3F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11C40, 0x11C40, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11C50, 0x11C59, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x11C72, 0x11C8F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11C92, 0x11CA7, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11CA9, 0x11CB6, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11D00, 0x11D06, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11D08, 0x11D09, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11D0B, 0x11D30, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11D31, 0x11D36, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11D3A, 0x11D3A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11D3C, 0x11D3D, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11D3F, 0x11D45, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11D46, 0x11D46, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11D47, 0x11D47, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11D50, 0x11D59, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x11D60, 0x11D65, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11D67, 0x11D68, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11D6A, 0x11D89, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11D8A, 0x11D8E, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11D90, 0x11D91, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11D93, 0x11D97, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x11D98, 0x11D98, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11DA0, 0x11DA9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x11EE0, 0x11EF2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x11EF3, 0x11EF6, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x12000, 0x12399, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x12400, 0x1246E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x12480, 0x12543, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x13000, 0x1342E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x13430, 0x13438, CharProperty.Format),
  UnicodeRange<CharProperty>(0x14400, 0x14646, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16800, 0x16A38, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16A40, 0x16A5E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16A60, 0x16A69, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x16AD0, 0x16AED, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16AF0, 0x16AF4, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x16B00, 0x16B2F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16B30, 0x16B36, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x16B40, 0x16B43, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16B50, 0x16B59, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x16B63, 0x16B77, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16B7D, 0x16B8F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16E40, 0x16E7F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16F00, 0x16F4A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16F4F, 0x16F4F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x16F50, 0x16F50, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16F51, 0x16F87, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x16F8F, 0x16F92, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x16F93, 0x16F9F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16FE0, 0x16FE1, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x16FE3, 0x16FE3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1B000, 0x1B000, CharProperty.Katakana),
  UnicodeRange<CharProperty>(0x1B164, 0x1B167, CharProperty.Katakana),
  UnicodeRange<CharProperty>(0x1BC00, 0x1BC6A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1BC70, 0x1BC7C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1BC80, 0x1BC88, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1BC90, 0x1BC99, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1BC9D, 0x1BC9E, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1BCA0, 0x1BCA3, CharProperty.Format),
  UnicodeRange<CharProperty>(0x1D165, 0x1D169, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1D16D, 0x1D172, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1D173, 0x1D17A, CharProperty.Format),
  UnicodeRange<CharProperty>(0x1D17B, 0x1D182, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1D185, 0x1D18B, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1D1AA, 0x1D1AD, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1D242, 0x1D244, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1D400, 0x1D454, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D456, 0x1D49C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D49E, 0x1D49F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D4A2, 0x1D4A2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D4A5, 0x1D4A6, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D4A9, 0x1D4AC, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D4AE, 0x1D4B9, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D4BB, 0x1D4BB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D4BD, 0x1D4C3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D4C5, 0x1D505, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D507, 0x1D50A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D50D, 0x1D514, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D516, 0x1D51C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D51E, 0x1D539, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D53B, 0x1D53E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D540, 0x1D544, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D546, 0x1D546, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D54A, 0x1D550, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D552, 0x1D6A5, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D6A8, 0x1D6C0, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D6C2, 0x1D6DA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D6DC, 0x1D6FA, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D6FC, 0x1D714, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D716, 0x1D734, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D736, 0x1D74E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D750, 0x1D76E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D770, 0x1D788, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D78A, 0x1D7A8, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D7AA, 0x1D7C2, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D7C4, 0x1D7CB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1D7CE, 0x1D7FF, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1DA00, 0x1DA36, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1DA3B, 0x1DA6C, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1DA75, 0x1DA75, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1DA84, 0x1DA84, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1DA9B, 0x1DA9F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1DAA1, 0x1DAAF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E000, 0x1E006, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E008, 0x1E018, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E01B, 0x1E021, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E023, 0x1E024, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E026, 0x1E02A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E100, 0x1E12C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1E130, 0x1E136, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E137, 0x1E13D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1E140, 0x1E149, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1E14E, 0x1E14E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1E2C0, 0x1E2EB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1E2EC, 0x1E2EF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E2F0, 0x1E2F9, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1E800, 0x1E8C4, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1E8D0, 0x1E8D6, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E900, 0x1E943, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1E944, 0x1E94A, CharProperty.Extend),
  UnicodeRange<CharProperty>(0x1E94B, 0x1E94B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1E950, 0x1E959, CharProperty.Numeric),
  UnicodeRange<CharProperty>(0x1EE00, 0x1EE03, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE05, 0x1EE1F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE21, 0x1EE22, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE24, 0x1EE24, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE27, 0x1EE27, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE29, 0x1EE32, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE34, 0x1EE37, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE39, 0x1EE39, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE3B, 0x1EE3B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE42, 0x1EE42, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE47, 0x1EE47, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE49, 0x1EE49, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE4B, 0x1EE4B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE4D, 0x1EE4F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE51, 0x1EE52, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE54, 0x1EE54, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE57, 0x1EE57, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE59, 0x1EE59, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE5B, 0x1EE5B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE5D, 0x1EE5D, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE5F, 0x1EE5F, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE61, 0x1EE62, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE64, 0x1EE64, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE67, 0x1EE6A, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE6C, 0x1EE72, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE74, 0x1EE77, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE79, 0x1EE7C, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE7E, 0x1EE7E, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE80, 0x1EE89, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EE8B, 0x1EE9B, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EEA1, 0x1EEA3, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EEA5, 0x1EEA9, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1EEAB, 0x1EEBB, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F130, 0x1F149, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F150, 0x1F169, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F170, 0x1F189, CharProperty.ALetter),
  UnicodeRange<CharProperty>(0x1F1E6, 0x1F1FF, CharProperty.RegionalIndicator),
  UnicodeRange<CharProperty>(0x1F3FB, 0x1F3FF, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xE0001, 0xE0001, CharProperty.Format),
  UnicodeRange<CharProperty>(0xE0020, 0xE007F, CharProperty.Extend),
  UnicodeRange<CharProperty>(0xE0100, 0xE01EF, CharProperty.Extend)
]);
